Subject: Re: bug#76769: 31.0.50; marking inconsistency between VC-Dir and dired-vc-next-action

From: Spencer Baugh <[email-masked]>
Date: Tue, 01 Apr 2025 17:44:52 -0400

Sean Whitton <[email-masked]> writes:

> Hello,
>
> I discovered another inconsistency in current VC-Dir which must be
> resolved first.  Suppose you have:
>
>                          ./
>   *                      admin/
>      edited              admin/emake
>                          admin/notes/
>      edited              admin/notes/www
>
>
> and then you move point to admin/notes/ and type 'm'.
> This is allowed.  The marks become:
>
>                          ./
>   *                      admin/
>      edited              admin/emake
>   *                      admin/notes/
>      edited              admin/notes/www
>
>
> However, if you instead start with this:
>
>                          ./
>                          admin/
>      edited              admin/emake
>   *                      admin/notes/
>      edited              admin/notes/www
>
> and then you move point to admin/ and type 'm', it's an error.
> It won't let you mark admin/.
>
> *If* it is allowed to have both admin/ and admin/notes/ marked,
> then it shouldn't matter which order you mark them in.
>
> I think I should change it to *not* allow admin/notes/ to be marked at
> the same time as admin/.  Does that sound right to others?

So it's already possible to have a directory and its subdirectory in the
same fileset?  So vc backends already need to support filesets which
contain both a directory and an entry in that directory?

Isn't this good news?  Because it means we could actually have vc-dir
allow "filesets which contain a directory and a file in that directory"
more generally, as in your original proposal on this bug.  Since, after
all, it seems to already be supported.